
angular.module('app.directives', [])

.directive('amRadar', function ($timeout) {
    return {
        restrict: 'E',
        replace: true,
        template: ['<div class="amRadarParent">',
                        '<div id="amRadarWrapper">',
                            '<div id="amRadNeedle" class="radar-spin"></div>', // class="radar-spin"
                                '<div class="amRadarUnits">',
                                  '<div class="xUnits">',
                                    '<div class="xLeft1">{{units[0]}}</div><div class="xLeft2">{{units[1]}}</div><div class="xLeft3">{{units[2]}}</div>',
                                    '<div class="xRight1">{{units[0]}}</div><div class="xRight2">{{units[1]}}</div><div class="xRight3">{{units[2]}}</div>',
                                  '</div>',
                                  '<div class="yUnits">',
                                    '<div class="yTop1">{{units[0]}}</div><div class="yTop2">{{units[1]}}</div><div class="yTop3">{{units[2]}}</div>',
                                    '<div class="yBottom1">{{units[0]}}</div><div class="yBottom2">{{units[1]}}</div><div class="yBottom3">{{units[2]}}</div>',
                                  '</div>',
                                '</div>',
                        '</div>',
                    '</div>'].join(''),
        scope: {
            units: '=?'
        },
        link: function ($scope, $element, $attrs) {
            var $meters = ['30m', '50m', '75m'];
            var $feets = ['100ft', '175ft', '250ft'];
            var dUnit = localStorage.getItem("DEFAULT_DISTANCE_UNIT") ? localStorage.getItem("DEFAULT_DISTANCE_UNIT") : "M"; // if null or something then show meters
            $scope.units = dUnit == "M" ? $meters : $feets;
        
            var $radarNeedle = $('#amRadNeedle'),
                deg = 0,
                rad = 160.5,
                rotateId,
                $rotateRequest,
                rotateInterval = 1000/60;
           
           var requestAnimation = function (callback) {
                return window.requestAnimationFrame || window.webkitRequestAnimationFrame || window.mozRequestAnimationFrame || window.oRequestAnimationFrame || window.msRequestAnimationFrame ||
                    function (callback) {
                        window.setTimeout(callback, 1000);
                    };
            };
           
            var clearAnimation = function(){
                if(rotateId){
                    window.cancelAnimationFrame(rotateId);
                }
            }
           
           var rotate = function() {
                $("#amRadNeedle").css({transform: 'rotate('+ deg +'deg)'});
                deg = ++deg%360;
                rotateId = setTimeout(function(){ rotate(); }, 25);
                //rotateId = $rotateRequest(rotate, rotateInterval);
                //debugError("rotate");
            };
            //setTimeout(function(){ rotate(); }, 1000);
           //$rotateRequest = requestAnimation();
           //rotateId = $rotateRequest(rotate, rotateInterval);
           
           $scope.$on('application_paused', function(e){
                $("#amRadNeedle").removeClass("radar-spin");
                //clearAnimation();
                //if(rotateId) clearTimeout(rotateId);
                $app.stopCompass();
            });
    
            $scope.$on('application_resumed', function(e){
                $("#amRadNeedle").addClass("radar-spin");
                //rotateId = $rotateRequest(rotate, rotateInterval);
                $app.startRadar();
            });
           
           $scope.$on('$destroy', function () {
              if(rotateId) clearTimeout(rotateId);
              //clearAnimation();
              console.log("radar stopped...!!!");
           });
           
        }
    }
})
.directive('searchBar', function ($timeout) {
    return {
        restrict: 'E',
        replace: true,
        require: '^ngModel',
        template: '<ion-header-bar class="bar-subheader item-input-inset">'+
                        '<label class="item-input-wrapper">'+
                            '<i class="icon ion-ios7-search placeholder-icon"></i>'+
                            '<input type="text" ng-model="ngModel" placeholder="Search">'+
                            '<i class="icon ion-ios7-close" style="color:#888; font-size:15pt;" ng-click="clearField()"></i>'+
                        '</label>'+
                    '</ion-header-bar>',
        scope: {
            ngModel: '='
        },
        link: function ($scope, $element, $attrs) {
           $scope.clearField = function(){
             alert("clicked...");
             $scope.ngModel = "";
           }
        }
    }
})
.directive('ionSearch', function () {
    return {
        restrict: 'E',
        replace: true,
        scope: {
            getData: '&source',
            model: '=?',
            search: '=?filter'
        },
        link: function (scope, element, attrs) {
            attrs.minLength = attrs.minLength || 0;
            scope.placeholder = attrs.placeholder || '';
            scope.search = { value: '' };

            if (attrs.class)
                element.addClass(attrs.class);

            if (attrs.source) {
                scope.$watch('search.value', function (newValue, oldValue) {
                    if (newValue.length > attrs.minLength) {
                        scope.getData({ str: newValue }).then(function (results) {
                            scope.model = results;
                        });
                    } else {
                        scope.model = [];
                    }
                });
            }

            scope.clearSearch = function () {
                scope.search.value = '';
            };
        },
        template: '<div class="item-input-wrapper">' +
                    '<i class="icon ion-android-search"></i>' +
                    '<input type="search" placeholder="{{placeholder}}" ng-model="search.value">' +
                    '<i ng-if="search.value.length > 0" ng-click="clearSearch()" class="icon ion-close"></i>' +
                  '</div>'
    };
})
.directive('ionNetwork', function ($interval, $timeout, $ionicPopup, $rootScope, service, LocationHandler) {
    return {
        restrict: 'A',
        scope: {
            interval: '@?ionNetwork'
        },
        link: function (scope, element) {
            //debugError("in ionNetwork");
            //debugError("typeof window.cordova: " + typeof window.cordova);
            if (window.cordova) {
                //debugError("in window.cordova");
                var allowedNetworkStates = [Connection.WIFI, Connection.CELL_4G, Connection.CELL_3G, Connection.CELL_2G, Connection.UNKNOWN, Connection.ETHERNET, Connection.CELL];
                var disabledTags = ['input', 'button', 'textarea', 'select'];
                var tag = element[0].tagName.toLowerCase();
                scope.interval = parseInt(scope.interval) || 500;
                var alertShown = false;
                var loggedIn = false, locationInitiated = false;
           
                function checkNetworkState() {
                    //debugError("navigator.connection.type: " + navigator.connection.type);
                    if(currentNetwork != navigator.connection.type){
                        currentNetwork = navigator.connection.type;
                        $rootScope.$broadcast("network.changed");
                        debugError("currentNetwork: " + currentNetwork);
                    }
                    if (allowedNetworkStates.indexOf(navigator.connection.type) === -1 || !navigator.onLine) {
           
                        $rootScope.isConnected = false;
                        if(!alertShown){
                            alertShown = true;
           
                            /*navigator.notification.alert(
                                'Move to an area with Cell or WiFi service.',
                                function(){
                                },
                                'Service not available',
                                'OK'
                            );*/
           
                            locationInitiated = false;
                        }
                    } else {
                        $rootScope.isConnected = true;
                        if(alertShown){
                            alertShown = false;
                        }
           
                        if(!locationInitiated && service.AcceptedMeetupsCount() > 0){
                            LocationHandler.watchLocation();
                            locationInitiated = true;
                        }
                    }
                }
                //debugError("before calling checkNetworkState()");
                checkNetworkState();
                stop = $interval(checkNetworkState, scope.interval);

                scope.$on('$destroy', function() {
                    //$interval.cancel(stop);
                });
            }
        }
    };
})
.directive('shortenText', function() {
  return {
  restrict: 'AE',
  link: function(scope, elm, attrs) {
        scope.$watch(elm, function (nTitle) {
            var nTitle = $.trim($(elm).html());
            var length = attrs.shortenText != "" ? parseInt(attrs.shortenText) : 15;
            if(nTitle.length > length){
                $(elm).html(nTitle.substr(0, length) + "...");
            }
        });
      }
  }
})
.directive('qTip', function() {
  return {
  restrict: 'AE',
  link: function(scope, elm, attrs) {
        debugError("qTip: " + attrs.qTip);
        $(elm).qtip({
            content: {
                //title:"Test tile",
                text: attrs.qTip,
                button: true
            },
            position: {
                my: 'bottom center',
                at: 'top center'
            },
            show: {
                when: false, // Don't specify a show event
                ready: true // Show the tooltip when ready
            },
            hide: false,
            style: {
                classes: 'qtip-dark'
            }
        });
      }
  }
})
.directive('windowWidth', function() {
  return {
  restrict: 'AE',
  link: function(scope, elm, attrs) {
        scope.$watch(elm, function (nTitle) {
            $(elm).width($(window).width());
        });
      }
  }
})
.directive('checkOsVersion', function(service) {
  return function(scope, elm, attrs) {
    //alert("WTF");
    var ios_ver = service.iOSversion();
    console.log("ios_ver: " + ios_ver);
    if(ios_ver){
        alert("ios version: " + ios_ver[0]);
        //$(elm).addClass("ios8");
    }
  };
})
.directive('amBlur', function() {
  return function(scope, elm, attrs) {
    setTimeout(function(){
        elm[0].blur();
    }, 100);
  };
})
.directive('autoFocus',function($timeout) {
  return {
    link : function($scope, $element) {
      $timeout(function() {
        $element[0].focus();
      }, 1000);
    }
  }
})
.directive('onKeyup', function() {
  return function(scope, elm, attrs) {
    elm.bind("keyup", function() {
      scope.$apply(attrs.onKeyup);
    });
  };
})
.directive('showLoaderOnClick', function() {
  return function(scope, elm, attrs) {
    var oldHTML = $(elm).html();
    elm.bind("click", function() {
      $(elm).html("<i class='icon bold ion-loading-d'></i>");
    });
    scope.$on('$destroy', function(){
        $(elm).html(oldHTML);
    });
  };
})
.directive('onVideoEnded', function() {
  return function(scope, elm, attrs) {
    elm.bind("ended", function() {
      scope.$apply(attrs.onVideoEnded);
    });
  };
})
.directive('disableOnClick', function() {
  return function(scope, elm, attrs) {
    elm.bind("click", function() {
      $(elm).prop("disabled", true);
    });
  };
})
.directive('onFocus', function() {
  return function(scope, elm, attrs) {
    elm.bind("focus", function() {
      scope.$apply(attrs.onFocus);
      this.focus();
    });
  };
})
.directive('onBlur', function() {
  return function(scope, elm, attrs) {
    elm.bind("blur", function() {
      scope.$apply(attrs.onBlur);
    });
  };
})
.directive('focusInput', function($timeout) {
  return {
    link: function(scope, element, attrs) {
      element.bind('click', function() {
        $timeout(function() {
          element.parent().parent().find('input')[0].focus();
        });
      });
    }
  };
})
.directive('focusOnBlur', function() {
  return function(scope, elm, attrs) {
    elm.bind("blur", function() {
      this.focus();
    });
  };
})
.directive('focusOnClick', function() {
  return function(scope, elm, attrs) {
    elm.bind("click", function() {
      $(attrs.focusOnClick).focus();
    });
  };
})
.directive('isFocused', function($timeout) {
      return {
        scope: { trigger: '@isFocused' },
        link: function(scope, element) {
          scope.$watch('trigger', function(value) {
            if(value === "true") {
              $timeout(function() {
                element[0].focus();

                element.on('blur', function() {
                  element[0].focus();
                });
              });
            }

          });
        }
      };
    })
.directive('focusOnKeyboardOpen', function($window){
  'use strict';
  return {
    restrict: 'A',
    link: function(scope, element, attrs){
      var keyboardOpen = false;
      // require cordova plugin https://github.com/driftyco/ionic-plugins-keyboard
      $window.addEventListener('native.keyboardshow', function(e){
        keyboardOpen = true;
        element[0].focus();
      });
      $window.addEventListener('native.keyboardhide', function(e){
        keyboardOpen = false;
        element[0].blur();
      });

      element[0].addEventListener('blur', function(e){
        if(keyboardOpen){
          element[0].focus();
        }
      }, true);
    }
  };
})
.directive('capitalizeWords', function() {
  return function(scope, elm, attrs) {
    elm.bind("keyup", function() {
      //scope.$apply(attrs.onKeyup);
      this.value = this.value.capitalize(false);
    });
  };
})
.directive('setDefaultTime', function() {
  return function(scope, elm, attrs) {
    var date = new Date();
    elm[0].valueAsDate = date;
    elm[0].value = date.toString("h:mm tt");
    //$(elm).val(date.toString("h:mm tt"));
  };
})

.directive('resize', function ($window) {
    return function (scope, element) {
        var w = angular.element($window);
        scope.getWindowDimensions = function () {
            return { 'h': w.height(), 'w': w.width() };
        };
        scope.$watch(scope.getWindowDimensions, function (newValue, oldValue) {
            scope.windowHeight = newValue.h;
            scope.windowWidth = newValue.w;

            scope.style = function () {
                return { 
                    'height': (newValue.h - 100) + 'px',
                    'width': (newValue.w - 100) + 'px' 
                };
            };

        }, true);

        w.bind('resize', function () {
            scope.$apply();
        });
    }
})
.directive('onValidSubmit', ['$parse', '$timeout', function ($parse, $timeout) {
    return {
        require: '^form',
        restrict: 'A',
        link: function (scope, element, attrs, form) {
            form.$submitted = false;
            var fn = $parse(attrs.onValidSubmit);
            element.on('submit', function (event) {
                scope.$apply(function () {
                    element.addClass('ng-submitted');
                    form.$submitted = true;
                    if (form.$valid) {
                        if (typeof fn === 'function') {
                            fn(scope, { $event: event });
                        }
                    }
                });
            });
        }
    }

}])
.directive('validated', ['$parse', function ($parse) {
    return {
        restrict: 'AEC',
        require: '^form',
        link: function (scope, element, attrs, form) {
            var inputs = element.find("*");
            for (var i = 0; i < inputs.length; i++) {
                (function (input) {
                    var attributes = input.attributes;
                    if (attributes.getNamedItem('ng-model') != void 0 && attributes.getNamedItem('name') != void 0) {
                        var field = form[attributes.name.value];
                        if (field != void 0) {
                            scope.$watch(function () {
                                return form.$submitted + "_" + field.$valid;
                            }, function () {
                                if (form.$submitted != true) return;
                                var inp = angular.element(input);
                                if (inp.hasClass('ng-invalid')) {
                                    inp.removeClass('has-success');
                                    inp.addClass('has-error');
                                } else {
                                    inp.removeClass('has-error').addClass('has-success');
                                }
                            });
                        }
                    }
                })(inputs[i]);
            }
        }
    }
}])
.directive('preventDefault', function() {
    return {
        restrict: 'E',
        link: function(scope, elem, attrs) {
            if(attrs.ngClick || attrs.href === '' || attrs.href === '#'){
                elem.on('click', function(e){
                    e.preventDefault();
                });
            }
        }
   };
})
.directive('ngFocus', ['$parse', function($parse) {
    return function(scope, element, attr) {
        var fn = $parse(attr['ngFocus']);
        element.on('focus', function(event) {
            scope.$apply(function() {
                fn(scope, {$event:event});
            });
        });
    };
}])
.directive('ngBlur', ['$parse', function($parse) {
    return function(scope, element, attr) {
        var fn = $parse(attr['ngBlur']);
        element.on('blur', function(event) {
            scope.$apply(function() {
                fn(scope, {$event:event});
            });
        });
    };
}])
//<map on-create="mapCreated(map)" center="scope_variable" spot="scope_variable"></map>
.directive('googleMap', function () {
    return {
        restrict: 'E',
        scope: {
            center: '=?',
            spot: '=?',
            onCreate: '&'
        },
        link: function ($scope, $element, $attr) {
            var marker, map, bound;
           // var directionsDisplay;
           // var directionsService = new google.maps.DirectionsService();

            function initialize() {
                debugError("$scope.center: " + $scope.center);
               // directionsDisplay = new google.maps.DirectionsRenderer();
                var mapOptions = {

                    center: new google.maps.LatLng($scope.center[0], $scope.center[1]),
                    //zoom: 16,
                    mapTypeId: google.maps.MapTypeId.ROADMAP,
                    disableDefaultUI: true,
                };

                map = new google.maps.Map($element[0], mapOptions);
                
                var image = new google.maps.MarkerImage(
                   'images/pointx.png',
                    null, // size
                    null, // origin
                    new google.maps.Point(40, 28), // anchor (move to center of marker)
                    new google.maps.Size(72, 72) // scaled size (required for Retina display icon)
                );

                var image2 = new google.maps.MarkerImage(
							'images/bluedot_retina.png',
							null, // size
							null, // origin
							new google.maps.Point(8, 8),// anchor (move to center of marker)
						   new google.maps.Size(16, 16) // scaled size (required for Retina display icon)
						);



                marker = new google.maps.Marker({
                    map: map,
                    position: new google.maps.LatLng($scope.center[0], $scope.center[1]),
                    icon: image2,
                    flat: true,
                    optimized: false,
                    visible: true,
                    title: 'Saved Spot',

                });

                var spotMarker = new google.maps.Marker({
                    flat: true,
                    optimized: false,
                    map: map,
                    position: new google.maps.LatLng($scope.spot[0], $scope.spot[1]),
                    icon: image,
                    //title: 'Saved Spot',
                    visible: true
                    //position: new google.maps.LatLng($scope.spot[0], $scope.spot[1]),
                });
               // directionsDisplay.setMap(map);
                bound = new google.maps.LatLngBounds();
                bound.extend(spotMarker.getPosition());
                bound.extend(marker.getPosition());
                map.fitBounds(bound);
           
                $scope.onCreate({ map: map });
                //map.setCenter(new google.maps.LatLng($scope.center[0], $scope.center[1]));
                
                // Stop the side bar from dragging when mousedown/tapdown on the map
                google.maps.event.addDomListener($element[0], 'mousedown', function (e) {
                    e.preventDefault();
                    return false;
                });
            }


            //function calcRoute() {
            //    var start = new google.maps.LatLng($scope.center[0], $scope.center[1]);
            //    var end = new google.maps.LatLng($scope.spot[0], $scope.spot[1]);
            //    var request = {
            //        origin: start,
            //        destination: end,
            //        travelMode: google.maps.TravelMode.DRIVING,
            //        provideRouteAlternatives: false,
            //    };
            //    directionsService.route(request, function (result, status) {
            //        if (status == google.maps.DirectionsStatus.OK) {
            //            directionsDisplay.setDirections(result);
            //        }
            //    });
            //}


           
            $($element[0]).on('click', 'a', function(e){
                e.preventDefault();
                window.open($(this).attr('href'), '_system');
            });
           
            $scope.$watch('center', function (newValue, oldValue) {
                if (newValue !== oldValue) {
                    //alert('center changed...');
                    marker.setPosition(new google.maps.LatLng($scope.center[0], $scope.center[1]));
                    //calcRoute();
                    //  map.setCenter(new google.maps.LatLng($scope.center[0], $scope.center[1]));
                }
            });



            $scope.$on('map.reload', function (e) {
                initialize();
            });

            if (document.readyState === "complete") {
                initialize();
                //initialize();
            } else {
                google.maps.event.addDomListener(window, 'load', initialize);
                //google.maps.event.addDomListener(window, 'load', initialize);
            }
        }
    }
})
.directive('disableMe', function() {
    return {
        restrict: 'AE',
        link: function(scope, elem, attrs) {
           elem.bind('click', function(e){
              if(attrs.disableMe == "true"){
                e.preventDefault();
                e.stopImmediatePropagation();
               }
            });
        }
   };
})
.directive('dynamic', function ($compile) {
  return {
    restrict: 'A',
    replace: true,
    link: function (scope, ele, attrs) {
      scope.$watch(attrs.dynamic, function(html) {
        ele.html(html);
        $compile(ele.contents())(scope);
      });
    }
  };
});