angular.module('app.filters', ['app.utils'])
  .filter('contactFilter', function (utils) {

      return function (input, query) {
          if (!query) return input;
          var result = [];

          angular.forEach(input, function (contact) {
              if (utils.compareStr(contact.CONTACT_NAME, query))
                  result.push(contact);
          });
          return result;
      };
  })
  .filter('unique', function() {
   return function(collection, keyname) {
      var output = [], 
          keys = [];

      angular.forEach(collection, function(item) {
          var key = item[keyname];
          if(keys.indexOf(key) === -1) {
              keys.push(key);
              output.push(item);
          }
      });

      return output;
   };
})
.filter('startFrom', function() {
    return function(input, start) {         
        return input.slice(start);
    }
});