var approachMe = angular.module('app', ['ionic', 'app.services', 'app.controllers', 'app.directives', 'app.utils', 'app.filters'])

.config(function ($stateProvider, $urlRouterProvider, $ionicConfigProvider) {

    // Set up the initial routes that our app will respond to.
    // These are then tied up to our nav router which animates and
    // updates a navigation bar
    $stateProvider

    .state('RadarView', {
        url: '/RadarView',
        templateUrl: '/RadarView.html',
        controller: 'RadarViewCtrl'
    })
    .state('RadarViewParam', {
        url: '/RadarView/:param',
        templateUrl: '/RadarView.html',
        controller: 'RadarViewCtrl'
    })
    .state('Settings', {
        url: '/Settings',
        templateUrl: '/Settings.html',
        controller: 'SettingsCtrl'
    })

    .state('Debug', {
        url: '/Debug',
        templateUrl: '/Debug.html',
        controller: 'DebugCtrl'
    })

    .state('Dashboard', {
        // cache: false,
        url: '/Dashboard',
        templateUrl: '/Dashboard.html',
        controller: 'DashboardCtrl'
    })
    .state('DashboardParams', {
        //cache: false,
        url: '/Dashboard/:qString',
        templateUrl: '/Dashboard.html',
        controller: 'DashboardCtrl'
    })

    .state('SavedLocations', {
        cache: false,
        url: '/SavedLocations',
        templateUrl: '/SavedLocations.html',
        controller: 'SavedLocationsCtrl'
    })

     .state('SavedLocationsParams', {
         cache: false,
         url: '/SavedLocations/:spotID',
         templateUrl: '/SavedLocations.html',
         controller: 'SavedLocationsCtrl'
     })
     .state('MyNotificationsCenter', {
         url: '/MyNotificationsCenter',
         templateUrl: '/MyNotificationsCenter.html',
         controller: 'MyNotificationsCenterCtrl'
     })


    // if none of the above routes are met, use this fallback
    $urlRouterProvider.otherwise('/Dashboard');
    // $ionicConfigProvider.views.transition('none');

});
//NSLocationWhenInUseUsageDescription
//NSLocationAlwaysUsageDescription
approachMe.run(function ($ionicPlatform, $rootScope, $ionicScrollDelegate, $timeout, $location, $interval, service, LocationHandler, $state) {
    debugError("pre-initializing...");
    /*$rootScope.$on('$stateChangeStart', function (event, toState, toParams, fromState, fromParams) {
        $timeout(function(){
            $('.qtip').qtip('hide');
        }, 1000);
    });*/

    if (localStorage.getItem("DEFAULT_DISTANCE_UNIT") == null) {
        localStorage.setItem("DEFAULT_DISTANCE_UNIT", "M");
    }

    $ionicPlatform.registerBackButtonAction(function (event) {
        if (($state.$current.name == "Dashboard") ||
            ($state.$current.name == "DashboardParams")) {
            // H/W BACK button is disabled for these states (these views)
            // Do not go to the previous state (or view) for these states. 
            // Do nothing here to disable H/W back button.
        } else {
            // For all other states, the H/W BACK button is enabled
            //alert(navigator.app.backHistory());
            if (($state.$current.name == "SavedLocations") && ($rootScope.showTutorial == true)) {
               
            }
            else {
                navigator.app.backHistory();
            }
        }
    }, 100);

    $ionicPlatform.ready(function () {
        debugError("platform ready...");
        cordova.getAppVersion(function (version) {
            $rootScope.app_version = version;
        });

        cordova.getAppVersion.getVersionCode(function (build) {
            //alert(code);
            $rootScope.build_version = build;
        });
        //cordova.getAppVersion.CFBundleVersion(function (build) {
        //    alert(build);
            
        //});
        localStorage.gpsInitialized = "false";

        
        $rootScope.NEW_NOTI_COUNT = "";
        service.GetNotification();
        if (!localStorage.getItem("firstTime")) {
            // localStorage.setItem("firstTime", "true");
            $rootScope.showTutorial = true;
        }
        else { $rootScope.showTutorial = false; }
        var isLoggedOut = localStorage.getItem("LOGOUT");
        debugError("isLoggedOutR: " + isLoggedOut);
        $rootScope.Android44 = false;
        $rootScope.Android40 = false;
        $rootScope.Iphone = false;
        var errorShown = false;
        $rootScope.isGps = true;
        $rootScope.isGpsEnabled = true;       

        if ((ionic.Platform.isAndroid() && ionic.Platform.version() >= 4.4) || ionic.Platform.isIOS()) {
            localStorage.setItem("platform", "Android44");
            $rootScope.Android44 = true;
            LocationHandler.watchLocation();            
        }
        if (ionic.Platform.isAndroid() && ionic.Platform.version() < 4.4) {
            localStorage.setItem("platform", "Android40");
            $rootScope.Android40 = true;
            LocationHandler.watchLocation();            
        }
        if (ionic.Platform.isIOS()) {
            localStorage.setItem("platform", "Iphone");
            $rootScope.Iphone = true;
            LocationHandler.watchLocation();
        }      

        document.addEventListener("pause", onPause, false);

        function onPause() {
            $rootScope.$broadcast("application_paused");
            debugError("onPause");
            IsRunnung = false;
            //if(isLoggedOut != "true" && service.AcceptedMeetupsCount() > 0){
            //    backgroundTrackerInit("start");
            //}
            //service.updateUserState(false);
        }

        document.addEventListener("resume", onResume, false);

        function onResume() {
            $rootScope.$broadcast("application_resumed");
            debugError("onResume");
            localStorage.gpsInitialized = "true";
            IsRunnung = true;
            debugError("isLoggedOutonResume: " + isLoggedOut);
            localStorage.gpsInitialized = "false";
            //if (localStorage.USER_ID && isLoggedOut != "true") {
            //    service.GetData(function(response){
            //        var pending_meetups = JSLINQ($rootScope.MEETUP_SPOTS).Where(function(i){ return i.CONTACT_STATUS == 'PENDING' });
            //        if(pending_meetups.Count() > 0){
            //            $location.path("/Events/VIEW_PENDING");
            //        }
            //    });

            //    backgroundTrackerInit("stop");

            //    if(service.AcceptedMeetupsCount() > 0){
            LocationHandler.watchLocation();
            //    }

            //}
            //service.updateUserState(true);
        }

        if (window.cordova) {
            cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
            cordova.plugins.Keyboard.disableScroll(true);
        }

        document.addEventListener("offline", function () {
            debugError("system offline");
            debugError("navigator.connection.type: " + navigator.connection.type);
            $rootScope.isConnected = false;
            //clear 
            
            $rootScope.popup_latitude = "";
            $rootScope.popup_longitude = "";
            $rootScope.popup_horizontal_accuracy = "";
            $rootScope.popup_vertical_accuracy = "";
            $rootScope.gpsstats = "no-gps";
            $rootScope.gps_accuracy = "poor poori";
            $rootScope.gps_accuracy_text = "Poor";
            $rootScope.isGPS = false;
            $rootScope.$apply();
        }, false);

        document.addEventListener("online", function () {
            debugError("system online");
            debugError("navigator.connection.type: " + navigator.connection.type);
            $rootScope.isConnected = true;
            //$rootScope.isGPS = true;
           
        }, false);

       // Gps status plugin only for android
        if (ionic.Platform.isAndroid()) {
            $timeout(function () {
                debugError("before window.plugins.gpsFix.getStatus");
                window.plugins.gpsFix.getStatus(function (data) {

                    debugError("getStatus() => " + JSON.stringify(data));
                    $rootScope.isGpsEnabled = data.gpsEnabled;
                    $rootScope.accuracy = data.accuracy;
                    $rootScope.grade = data.grade;
                    //if (!$rootScope.isGpsEnabled && !errorShown) {
                    //    if (ionic.Platform.isAndroid() && ionic.Platform.version() >= 4.4) {
                    //        service.alert(messages.ANDROID_WARNING);
                    //        $rootScope.Android44 = true;
                    //        errorShown = true;

                    //    }
                    //    else if (ionic.Platform.isAndroid() && ionic.Platform.version() < 4.4) {
                    //        service.alert(messages.LOCATION_WARNING_EARLY_ANDROID);
                    //        $rootScope.Android40 = true;
                    //        errorShown = true;
                    //    }                       
                    //}
                    $rootScope.$apply();
                }, function () { });
            }, 5000);

            //window.addEventListener('onLocationChanged', function (e) {
            //    debugError("onLocationChanged() ================>  acc: ");
            //    //$rootScope.accuracy = e.accuracy;
            //    //alert("onLocationChanged() =>  acc: " + e.accuracy);
            //    //$rootScope.$apply();
            //});


            window.addEventListener('onGpsStatusChanged', function (e) {
                debugError("onGpsStatusChanged() => " + e.gpsEnabled + "  acc: " + e.accuracy + "  gpsFix" + e.grade);
                $rootScope.isGpsEnabled = e.gpsEnabled;
                
                $rootScope.accuracy = e.accuracy;
                $rootScope.grade = e.grade;
                $rootScope.$apply();
                
                if (!$rootScope.isGpsEnabled && !errorShown) {
                    if (ionic.Platform.isAndroid() && ionic.Platform.version() >= 4.4) {
                        service.alert(messages.ANDROID_WARNING);
                        $rootScope.Android44 = true;
                        errorShown = true;

                    }
                    else if (ionic.Platform.isAndroid() && ionic.Platform.version() < 4.4) {
                        service.alert(messages.LOCATION_WARNING_EARLY_ANDROID);
                        $rootScope.Android40 = true;
                        errorShown = true;
                    }
                }

                $rootScope.$apply();
            });

           
        }


    });


});

