//[[UIApplication sharedApplication] openURL:[NSURL  URLWithString:UIApplicationOpenSettingsURLString]];
// colors to be used for radar points and radar list
var $colors = ["#eaff00", "#1d42ff", "#ff7800", "#00be36","#b1b1b1","#58e8fe","#004c6c","#525625","#3b8eff","#b37e00","#29e09e", "#97d960", "#449ae8", "#945b45", "#568c75", "#4bb7d6", "#b386ba", "#e183fb", "#f6bb1b", "#d08f89", "#e92c6d", "#c3480f", "#89a0e7", "#b28334", "#4b8785", "#e601e0", "#7e7bf9", "#fa9231", "#43587", "#dd7d60", "#1333b2", "#71633f", "#ef8aab", "#ce546a", "#b248b6", "#a6db85", "#aafade", "#d20d88", "#eb5a30", "#effce4", "#8ee989", "#8ca31e", "#b0ca83", "#882dc3", "#95d425", "#cc14d6", "#ca3138", "#62ec", "#b5798f", "#df251c", "#391ffb", "#90879d", "#35cf5d", "#3a5e80", "#5d570b", "#870f20", "#e68e7e", "#d7e21c", "#a7a031", "#2fceb5", "#c59f0b", "#bc253d", "#327dfd", "#fe93cd", "#d71beb", "#760a2d", "#22d768", "#bb6307", "#e9208f", "#d968d7", "#b23d81", "#87fdea", "#524bc6", "#79902b", "#ee1cdf", "#775606", "#bec924", "#acaa93", "#be4734", "#21ad54", "#5c9938", "#7c4e56", "#6ece81", "#443d42", "#63e3fd", "#a8d2be", "#bab1b6", "#fdbc43", "#3e6d56"];
/* Prototypes */

// First, checks if it isn't implemented yet.
if (!String.prototype.format) {
  String.prototype.format = function() {
    var args = arguments;
    return this.replace(/{(\d+)}/g, function(match, number) { 
      return typeof args[number] != 'undefined'
        ? args[number]
        : match
      ;
    });
  };
}

String.prototype.capitalize = function(lower) {
    return (lower ? this.toLowerCase() : this).replace(/(?:^|\s)\S/g, function(a) { return a.toUpperCase(); });
};

Array.prototype.equals = function (array) {
    // if the other array is a falsy value, return
    if (!array)
        return false;

    // compare lengths - can save a lot of time 
    if (this.length != array.length)
        return false;

    for (var i = 0, l=this.length; i < l; i++) {
        // Check if we have nested arrays
        if (this[i] instanceof Array && array[i] instanceof Array) {
            // recurse into the nested arrays
            if (!this[i].equals(array[i]))
                return false;       
        }           
        else if (this[i] != array[i]) { 
            // Warning - two different object instances will never be equal: {x:20} != {x:20}
            return false;   
        }           
    }       
    return true;
}

if ( !String.prototype.contains ) {
    String.prototype.contains = function() {
        return String.prototype.indexOf.apply( this, arguments ) !== -1;
    };
}

Array.prototype.move = function (old_index, new_index) {
    if (new_index >= this.length) {
        var k = new_index - this.length;
        while ((k--) + 1) {
            this.push(undefined);
        }
    }
    this.splice(new_index, 0, this.splice(old_index, 1)[0]);
    return this; // for testing purposes
};

if (typeof String.prototype.startsWith != 'function') {
  // see below for better implementation!
  String.prototype.startsWith = function (str){
    return this.indexOf(str) == 0;
  };
}

Date.prototype.addYears= function(year){
    this.setFullYear(this.getFullYear() + year);
    return this;
}
Date.prototype.addDays= function(days){
    this.setDate(this.getDate() + days);
    return this;
}
Date.prototype.addHours= function(h){
    this.setHours(this.getHours() + h);
    return this;
}

/* /Prototypes */

window.ChatMessages = {};
// Global Variables
var URL = "",//http://service.v2.approachme.net/api/webservice/
    RadarList = [],
    //ChatMessages = {},
    appScope,
    appScrollDelegate,
    pushNotification,
    Requests = [],
    MyFriends = [],
    MeetupSpots = [],
    MeetupSpotID,
    MyMessages = [],
    IsRunnung = true,
    MSG_ID = 0,
    compassHeading,
    GlobalCoords = { LATITUDE: "", LONGITUDE: "" },
    backgroundTracker,
    inRangeNotification = [],
    defaultAvatar = "images/male.png",
    MaxSpots = 5,
    MaxFriends = 5,
    isInRangeForLocUpdate = false,
    msgLoadInterval,
    contactsErrorDisplayed = false,
    MEETUP_NOW_HOURS = 6,
    meColor = "#fff",
    currentNetwork = ""; // used when user wants to leave spot from RadarView


/*
RadarList =
[
    {
        USER_ID: 1,
        THUMB: "http://img.approachme.net/cdv_photo_003.jpg",
        USER_NAME: "Edward",
        CURRENT_LOCATION: "Islamabad"
    },
    {
        USER_ID: 2,
        THUMB: "http://img.approachme.net/cdv_photo_003.jpg",
        USER_NAME: "Amy",
        CURRENT_LOCATION: "Islamabad"
    }
];
*/
var User = function () {
    this.USER_ID = "";
    this.USER_NAME = "";
    this.EMAIL_ADDRESS = "";
    this.GENDER = "";
    this.AGE = "";
    this.LOOKING_FOR_GENDER = "";
    this.LOOKING_FOR_AGE = "";
    this.PHONE_NUMBER = "";
    this.VERIFICATION_CODE = "";
    this.THUMB = "";
    this.CURRENT_LOCATION = "";
    this.COORDS = new Coords();
    this.DEVICE_TOKEN = "";
    this.DEVICE_CHANNEL = "";
    this.OS_VERSION = "";
    //this.CONNECTION_ID = "";
}

var Coords = function () {
    this.USER_ID = "";
    this.LATITUDE = "";
    this.LONGITUDE = "";
    //this.ACCURACY = "";
}

var Event = function () {
    this.EVENT_ID = "";
    this.EVENT_NAME = "";
    this.EVENT_TIME = "";
    this.EVENT_TYPE = "";
    this.EVENT_DURATION = "";
    this.EVENT_CONTACTS = [];
    this.EVENT_REQUESTS = [];
    this.USER_ID = "";
}

var EventType = { INSTANT: "INSTANT", SCHEDULED: "SCHEDULED" };

var radar, started = false, point, compassWatchID,
    chatModal = null;

var $app = {
    init: function () {
        debugError("> init");
    },
    initRadar: function () {
    },
    startRadar: function () {
        this.initCompass();
    },
    initCompass: function () {
        var $this = this;
        if (navigator.compass) {
            debugError("Compass triggered...");
            var options = { frequency: 100 };
            if (compassWatchID) navigator.compass.clearWatch(compassWatchID);
            
            compassWatchID = navigator.compass.watchHeading(function (heading) {
                var compassDiv = document.getElementById("compass");
                if(compassDiv){
                    var magneticHeading = 360 - heading.magneticHeading,
                        rotation = "rotate(" + magneticHeading + "deg)";
                    compassDiv.style.webkitTransform = rotation;
                    compassHeading = Math.round(heading.magneticHeading);
                    //debugError("magneticHeading: " + heading.magneticHeading);
                    //debugError("direction: " + getAngleString(heading.magneticHeading));
                    var uID = localStorage.getItem("USER_ID");
                    for (var i = 0; i < RadarList.length; i++) {
                        if(RadarList[i].USER_ID == uID){
                            RadarList[i].BEARING = getAngleString(heading.magneticHeading);
                        }
                    }
                }
            }, function (error) {
                var errorMessage = "";
                switch (error.code) {
                    case 20:
                    errorMessage = "Compass not supported";
                    break;
                    case 0:
                    errorMessage = "Compass internal error";
                    break;
                    default:
                    errorMessage = "Compass error";
                }
                //debugError("Compass Error: " + errorMessage);
            }, options);
        }
    },
    stopCompass:function(){
        if (compassWatchID){
            navigator.compass.clearWatch(compassWatchID);
            debugError("compass stopped...!!!");
        }
    },
    onDeviceReady: function () {
        if(localStorage["country_iso"]){
            hardLoadContacts(null);
        }
        
        pushNotification = window.plugins.pushNotification;
        if (device.platform == 'android' || device.platform == 'Android' || device.platform == 'amazon-fireos') {
            pushNotification.register(successHandler, errorHandler, { "senderID": "266683341923", "ecb": "onNotification" }); //
        } else {
            debugError("before registering...");
            pushNotification.register(tokenHandler, errorHandler, { "badge": "true", "sound": "true", "alert": "true", "ecb": "onNotificationAPN" });	// required!
        }

        // google analytics
        // https://github.com/danwilson/google-analytics-plugin
        analytics.startTrackerWithId("UA-60550930-1");
        debugError("google analytics initiated...");
        
        debugError("device.model: " + device.model);       
        

    }
    
};


    function backgroundTrackerInit(action) {
        //https://github.com/christocracy/cordova-plugin-background-geolocation
        backgroundTracker = window.plugins.backgroundGeoLocation;
        backgroundTracker.configure(callbackFn, failureFn, { desiredAccuracy: 10, stationaryRadius: 5, distanceFilter: 5, stopOnTerminate:true });
        
        debugError("isAnyMeetupJoined(): " + isAnyMeetupJoined());
        if(!isAnyMeetupJoined()){
            debugError("No meetup has joined yet, so background tracking will not be initiated");
            backgroundTracker.stop();
            return false;
        }
        else{
            debugError("background tracking initiated.");
            // Turn ON/OFF the background-geolocation system.
            if (action == 'stop') {
                backgroundTracker.stop();
                //window.plugins.backgroundjs.unlockBackgroundTime();// https://github.com/jocull/phonegap-backgroundjs
            }
            else if(action == 'start') {
                //bg Geolocation code
                backgroundTracker.start();
                //window.plugins.backgroundjs.lockBackgroundTime();
            }
        }
    }

    var isAnyMeetupJoined = function(){
        for(var i = 0; i < MeetupSpots.length; i++){
            if(MeetupSpots[i].CONTACT_STATUS == "APPROVED"){
                return true;
                break;
            }
        }
        return false;
    }

    var callbackFn = function(location) {
        debugError('[js] BackgroundGeoLocation callback:  ' + location.latitude + ',' + location.longitude);
        GlobalCoords = { LATITUDE: location.latitude, LONGITUDE: location.longitude };
        localStorage.setItem("latitude", location.latitude);
        localStorage.setItem("longitude", location.longitude);
        backgroundTracker.finish();
    };

    var failureFn = function(error) {
        debugError('BackgroundGeoLocation error: ' + JSON.stringify(error));
    }

document.addEventListener("deviceready", $app.onDeviceReady, false);

function get_contacts(callback, reloadFromPhonebook) {
    debugError("get_contacts");
    var phonebook;
    if(localStorage.phonebook){//) && (!reloadFromPhonebook || reloadFromPhonebook == false)){
        phonebook = JSON.parse(localStorage.phonebook);
        debugError("phonebook.contacts.length: " + phonebook.contacts.length);
        debugError("contact_access_allowed: " + localStorage.contact_access_allowed);
        if(localStorage.contact_access_allowed == "true"){
          if(callback){
            callback(phonebook.contacts);
          }
        }
        else{
            debugError("contact_access_not_allowed");
            //navigator.notification.alert(messages.CONTACTS_ACCESS_DENIED, null, 'ApproachMe', 'OK');
            if(callback){
                callback([]);
            }
        }
    }
    else{
        debugError("hard loading...");
        //if(reloadFromPhonebook && reloadFromPhonebook == true){
            hardLoadContacts(callback);
        //}
    }
}

function hardLoadContacts(callback){
    debugError("hardLoadContacts");
    var obj = new ContactFindOptions();
        obj.filter = "";
        obj.multiple = true;
        //navigator.contacts.loadAsynch(["displayName", "name", "phoneNumbers"], function(contacts){
         //   contacts_success(contacts, callback);
    // }, contacts_fail, obj);
        navigator.contacts.find(["displayName", "name", "phoneNumbers"], function (contacts) {
            contacts_success(contacts, callback);
        }, contacts_fail, obj);
}

function contacts_success(contacts, callback) {
    try {
        //debugError("contacts: " + JSON.stringify(contacts));
        debugError("contacts_success(): " + contacts.length);
        var phonebook = [];
        var tmp = contacts.sort(phonebook_compare),
            myNumber = localStorage.getItem("phoneNumber"),
            contactNum;
        debugError("myNumber: " + myNumber);
        for (var i = 0; i < tmp.length; i++) {
            if (tmp[i].phoneNumbers && tmp[i].phoneNumbers.length > 0) {
                for (var k = 0; k < tmp[i].phoneNumbers.length; k++) {
                    contactNum = formatNumber(tmp[i].phoneNumbers[k].value);
                    //debugError("contactNum: " + contactNum);
                    if (contactNum != myNumber) {
                        phonebook.push({ CONTACT_NAME: tmp[i].name.formatted, CONTACT_NUMBER: tmp[i].phoneNumbers[k].value, E164: contactNum });
                    }
                }
            }
        }
        localStorage.phonebook = JSON.stringify({ contacts: phonebook, count: phonebook.length });
        //debugError("phonebook: " + JSON.stringify(phonebook));
        if (callback) {
            callback(phonebook);
        }
        localStorage.contact_access_allowed = "true";
        delete phonebook;
    }
    catch (ex) {
        alert("contact access execption: " + ex);
    }
}
function contacts_fail(msg) {
    /*if(!contactsErrorDisplayed){
        navigator.notification.alert(messages.CONTACTS_ACCESS_DENIED, null, 'ApproachMe', 'OK');
        contactsErrorDisplayed = true;
    }*/
    localStorage.phonebook = JSON.stringify({ contacts:[], count: 0 });
    localStorage.contact_access_allowed = "false";
    debugError("get_contacts() Error: " + msg);
}

function formatNumber(phone){
    var country_iso = localStorage["country_iso"];
    //debugError("country_iso: " + country_iso);
    if(country_iso){
      var e164 = formatE164(country_iso, phone);// PK, US
      if (e164.substring(0, 1) == "+") {
        return e164;
      } else {
        return "+" + e164;
      }
    }
}

function phonebook_compare(a,b) {
  if ((a.name && a.name.formatted) < (b.name && b.name.formatted))
     return -1;
  if ((a.name && a.name.formatted) > (b.name && b.name.formatted))
    return 1;
  return 0;
}

function radar_compare(a,b) {
  if (a.USER_NAME < b.USER_NAME)
     return -1;
  if (a.USER_NAME > b.USER_NAME)
    return 1;
  return 0;
}

var debug = true;
var debugError = function (msg) {
    if (debug) {
      console.log(msg);
    }
}


var newGuid = function () {
    var template = 'xxxxxxxx';
    return template.replace(/[xy]/g, function (c) {
        var r = Math.random() * 16 | 0, v = c == 'x' ? r : (r & 0x3 | 0x8);
        return v.toString(16);
    });
};

var generateVerificationCode = function () {
    var chars = "0123456789";
    var string_length = 4;
    var randomstring = '';
    for (var i = 0; i < string_length; i++) {
        var rnum = Math.floor(Math.random() * chars.length);
        randomstring += chars.substring(rnum, rnum + 1);
    }
    return randomstring;
};
var random = generateVerificationCode;

var randomCSSColor = function(){
    return Math.floor(Math.random()*16777215).toString(16);
}

function getStyleProperty(el,styleProp){
        var x = el;//document.getElementById(el);

        if (window.getComputedStyle){
            var y = document.defaultView.getComputedStyle(x,null).getPropertyValue(styleProp);
        }
        else if (x.currentStyle){
            var y = x.currentStyle[styleProp];
        }
        return y;
     }

window.onerror = function (errorMsg, url, lineNumber, column, errorObj) {
    var error = JSON.stringify({ channel:"ANDROID", errorMsg: errorMsg, url: url, lineNumber: lineNumber, column: column, errorObj: errorObj });
    debugError("onError: " + error);
   //alert("onError: " + error);
    $.post(URL+"LogError", { USER_ID: localStorage.USER_ID, PHONE_NUMBER: localStorage.phoneNumber, ERROR_MESSAGE: error }, function(res){  }, "json");
}



